// For documentation of the format, see README in this directory.
var browserTests = [
["foo[bar]baz",
    [["defaultparagraphseparator",""]],
    "foo[bar]baz",
    [false],
    {"defaultparagraphseparator":[false,false,"div",false,false,"div"]}],
["foo[bar]baz",
    [["defaultparagraphseparator","div"]],
    "foo[bar]baz",
    [true],
    {"defaultparagraphseparator":[false,false,"div",false,false,"div"]}],
["foo[bar]baz",
    [["defaultparagraphseparator","p"]],
    "foo[bar]baz",
    [true],
    {"defaultparagraphseparator":[false,false,"div",false,false,"p"]}],
["foo[bar]baz",
    [["defaultparagraphseparator","DIV"]],
    "foo[bar]baz",
    [true],
    {"defaultparagraphseparator":[false,false,"p",false,false,"div"]}],
["foo[bar]baz",
    [["defaultparagraphseparator"," p "]],
    "foo[bar]baz",
    [false],
    {"defaultparagraphseparator":[false,false,"div",false,false,"div"]}],
["foo[bar]baz",
    [["defaultparagraphseparator","<p>"]],
    "foo[bar]baz",
    [false],
    {"defaultparagraphseparator":[false,false,"div",false,false,"div"]}],
["foo[bar]baz",
    [["defaultparagraphseparator","P"]],
    "foo[bar]baz",
    [true],
    {"defaultparagraphseparator":[false,false,"div",false,false,"p"]}],
["foo[bar]baz",
    [["defaultparagraphseparator"," div "]],
    "foo[bar]baz",
    [false],
    {"defaultparagraphseparator":[false,false,"p",false,false,"p"]}],
["foo[bar]baz",
    [["defaultparagraphseparator","<div>"]],
    "foo[bar]baz",
    [false],
    {"defaultparagraphseparator":[false,false,"p",false,false,"p"]}],
["foo[bar]baz",
    [["defaultparagraphseparator","li"]],
    "foo[bar]baz",
    [false],
    {"defaultparagraphseparator":[false,false,"p",false,false,"p"]}],
["foo[bar]baz",
    [["defaultparagraphseparator","blockquote"]],
    "foo[bar]baz",
    [false],
    {"defaultparagraphseparator":[false,false,"p",false,false,"p"]}],
["foo[bar]baz",
    [["selectall",""]],
    "foo[bar]baz",
    [true],
    {"selectall":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["stylewithcss","true"]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,false,"",false,true,""]}],
["foo[bar]baz",
    [["stylewithcss","TRUE"]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,true,"",false,true,""]}],
["foo[bar]baz",
    [["stylewithcss","TrUe"]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,true,"",false,true,""]}],
["foo[bar]baz",
    [["stylewithcss","true "]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,true,"",false,true,""]}],
["foo[bar]baz",
    [["stylewithcss"," true"]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,true,"",false,true,""]}],
["foo[bar]baz",
    [["stylewithcss","truer"]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,true,"",false,true,""]}],
["foo[bar]baz",
    [["stylewithcss"," true "]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,true,"",false,true,""]}],
["foo[bar]baz",
    [["stylewithcss"," TrUe"]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,true,"",false,true,""]}],
["foo[bar]baz",
    [["stylewithcss",""]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,true,"",false,true,""]}],
["foo[bar]baz",
    [["stylewithcss"," "]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,true,"",false,true,""]}],
["foo[bar]baz",
    [["stylewithcss","false"]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,true,"",false,false,""]}],
["foo[bar]baz",
    [["stylewithcss","FALSE"]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["stylewithcss","FaLsE"]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["stylewithcss"," false"]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,false,"",false,true,""]}],
["foo[bar]baz",
    [["stylewithcss","false "]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,true,"",false,true,""]}],
["foo[bar]baz",
    [["stylewithcss","falser"]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,true,"",false,true,""]}],
["foo[bar]baz",
    [["stylewithcss","falsé"]],
    "foo[bar]baz",
    [true],
    {"stylewithcss":[false,true,"",false,true,""]}],
["foo[bar]baz",
    [["usecss","true"]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["usecss","TRUE"]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["usecss","TrUe"]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["usecss","true "]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["usecss"," true"]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["usecss","truer"]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["usecss"," true "]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["usecss"," TrUe"]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["usecss",""]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["usecss"," "]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["usecss","false"]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["usecss","FALSE"]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["usecss","FaLsE"]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["usecss"," false"]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["usecss","false "]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["usecss","falser"]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["usecss","falsé"]],
    "foo[bar]baz",
    [true],
    {"usecss":[false,false,"",false,false,""]}],
["foo[bar]baz",
    [["quasit",""]],
    "foo[bar]baz",
    [false],
    {"quasit":[false,false,"",false,false,""]}]
]
